;    awguilayout.pbi
;    Version 0.5 [2012/05/06]
;    Copyright (C) 2012 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

;{ Fixes for Linux
CompilerIf #PB_Compiler_OS = #PB_OS_Linux
	ImportC "-gtk"
  	g_signal_connect_data(*widget,signal.p-utf8,*fn,*vdata,destroy)
	EndImport

	ProcedureC ____AWPB_GUILO_GtkWidgets_CB_SSR_TG(*label.GtkWidget, *allocation.GtkAllocation, *dummy)
  	gtk_widget_set_size_request_(*label, *allocation\width - 2, -1)
	EndProcedure
	ProcedureC ____AWPB_GUILO_GtkWidgets_CB_SSR_FG(*label.GtkWidget, *allocation.GtkAllocation, *daten)
		gtk_widget_set_size_request_(gtk_frame_get_label_widget_(*label), *allocation\width - 2, -1)
	EndProcedure
	
	Procedure AWPB_GUILO_Fix_TextGadget_Resize(GadgetID.i, EnableWordWrap.b)
		gtk_label_set_line_wrap_(GadgetID(GadgetID), EnableWordWrap)
		g_signal_connect_data(GadgetID(GadgetID), "size-allocate", @____AWPB_GUILO_GtkWidgets_CB_SSR_TG(), #Null, 0)
	EndProcedure 
	Procedure AWPB_GUILO_Fix_Frame3DGadget_Resize(GadgetID.i)
		g_signal_connect_data(GadgetID(GadgetID), "size-allocate", @____AWPB_GUILO_GtkWidgets_CB_SSR_FG(), #Null, 0)
	EndProcedure  
CompilerEndIf
;}
;{ Flags; public and internal
#AWPB_GUILO_SIZER_GADGET						=	$00000001
#AWPB_GUILO_SIZER_SPACER						=	$00000002
#AWPB_GUILO_SIZER_SIZER							=	$00000004
#AWPB_GUILO_SIZER_FRAME							=	$00000008
#AWPB_GUILO_SIZER_FIX								=	$00000010
#AWPB_GUILO_SIZER_REL								=	$00000020
#AWPB_GUILO_SIZER_VBOX							=	$00000040
#AWPB_GUILO_SIZER_HBOX							=	$00000080
#AWPB_GUILO_SIZER_PARENT_WINDOW			=	$00000100
#AWPB_GUILO_SIZER_PARENT_CONTAINER	=	$00000200
#AWPB_GUILO_SIZER_PARENT_FRAME			=	$00000400
;}
;{ CallBack Prototypes
PrototypeC AWPB_GUILO_OnBeforeResize_Proto(GadgetID.i)
PrototypeC AWPB_GUILO_OnAfterResize_Proto(GadgetID.i, Left.i, Top.i, Width.i, Height.i)
;}
;{ Support Procedures
Procedure.i ____AWPB_GetGadgetTextHeight(GadgetID.i)
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Linux
			Protected *Frame.GtkFrame, *Widget.GtkWidget, h
	 
			*Frame = GadgetID(GadgetID)
			If *Frame
				*Widget = gtk_frame_get_label_widget_(*Frame)
				If *Widget
					gtk_widget_get_size_request_(*Widget, #Null, @h)
					ProcedureReturn h
				EndIf
			EndIf
		CompilerCase #PB_OS_Windows
		  Protected *otm.OUTLINETEXTMETRIC, bsize.i, Font.i, hWnd.i, hdc.i, FontSize.i
  
  		hWnd  = GadgetID(GadgetID)
  	  Font  = GetGadgetFont(GadgetID) 
  		hdc   = GetDC_(hWnd)
  		Font  = SelectObject_(hdc, Font)
  		bsize = GetOutlineTextMetrics_(hdc, 0, 0)
  
  		If bsize = 0
    		SelectObject_(hdc, Font)
    		ReleaseDC_(hWnd, hdc)
    		ProcedureReturn 0
  		EndIf
  
  		*otm 				 = AllocateMemory(bsize)
  		*otm\otmSize = bsize
  
		  GetOutlineTextMetrics_(hdc, bsize, *otm)

  		FontSize = Int(Round((*otm\otmTextMetrics\tmHeight * 72.0 / GetDeviceCaps_(hdc, #LOGPIXELSY)), 1))
  
  		FreeMemory(*otm)
  		SelectObject_(hdc, Font)
  		ReleaseDC_(hWnd,hdc)

  		ProcedureReturn FontSize
	CompilerEndSelect
	
	ProcedureReturn 0	
EndProcedure
;}
;{ Support Macros
Macro IsFlag(X, Y)
	(((X) & (Y)) = Y)
EndMacro
;}
;{ Sizer Object
Interface AWPB_GUILO_Sizer
	Destroy      			()
	Finish	     			(ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	Resize       			(ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	AddGadget.b  			(ParentSizer.i, GadgetID.i, Size.i, BorderLeft.i = 0, BorderTop.i = 0, BorderRight.i = 0, BorderBottom.i = 0, *OnBeforeResizeCallback.AWPB_GUILO_OnBeforeResize_Proto = #Null, *OnAfterResizeCallback.AWPB_GUILO_OnAfterResize_Proto = #Null)
	AddSizer.i   			(ParentSizer.i, Flags.i, Size.i)
	AddSpacer.b  			(ParentSizer.i, Size.i)	
	AddFramedSizer.i	(ParentSizer.i, GadgetID.i, Flags.i, Size.i, BorderLeft.i = 0, BorderTop.i = 0, BorderRight.i = 0, BorderBottom.i = 0, InnerBorderLeft.i = #PB_Any, InnerBorderTop.i = #PB_Any, InnerBorderRight.i = #PB_Any, InnerBorderBottom.i = #PB_Any, *OnBeforeResizeCallback.AWPB_GUILO_OnBeforeResize_Proto = #Null, *OnAfterResizeCallback.AWPB_GUILO_OnAfterResize_Proto = #Null)
	MinWidth.i   			(ParentSizer.i = #Null)
	MinHeight.i  			(ParentSizer.i = #Null)
EndInterface
Structure ____AWPB_GUILO_Sizer_Data
	; calculated values
	l.i
	t.i
	r.i
	b.i
	w.i
	h.i
	
	; given values
	flags.i			; #AWPB_GUILO_SIZER_GADGET | #AWPB_GUILO_SIZER_SPACER | #AWPB_GUILO_SIZER_SIZER | #AWPB_GUILO_SIZER_FRAME | #AWPB_GUILO_SIZER_FIX | #AWPB_GUILO_SIZER_REL | #AWPB_GUILO_SIZER_VBOX | #AWPB_GUILO_SIZER_HBOX	
	size.i			; 0... px | 0..100 %
	bleft.i			; Outer Border Left
	btop.i			; Outer Border Top
	bright.i		; Outer Border Right
	bbottom.i		; Outer Border Bottom
	ibleft.i		; Inner Border Left
	ibtop.i			; Inner Border Top
	ibright.i		; Inner Border Right
	ibbottom.i	; Inner Border Bottom
	GadgetID.i	; Gadget Number if needed
	
	*OnBeforeResize.AWPB_GUILO_OnBeforeResize_Proto
	*OnAfterResize.AWPB_GUILO_OnAfterResize_Proto
	
	List *childs.____AWPB_GUILO_Sizer_Data()
EndStructure
Structure ____AWPB_GUILO_Sizer
	*vt.____AWPB_GUILO_Sizer_VT
	
	sizers.____AWPB_GUILO_Sizer_Data
	
	ParentID.i
EndStructure

Procedure.i AWPB_CreateSizerObj(ParentID.i)
	Protected *this.____AWPB_GUILO_Sizer
	
	If Not IsWindow(ParentID)
		If Not IsGadget(ParentID)
			ProcedureReturn #Null
		EndIf
		If (GadgetType(ParentID) <> #PB_GadgetType_Container) And (GadgetType(ParentID) <> #PB_GadgetType_Frame3D) 
			ProcedureReturn #Null
		EndIf
	EndIf
	
	*this = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer))
	If *this 
		InitializeStructure(*this, ____AWPB_GUILO_Sizer)
		*this\vt              = ?____AWPB_GUILO_Sizer_VT
		*this\ParentID        = ParentID
		*this\sizers\l        = 0
		*this\sizers\t        = 0
		
		If IsWindow(ParentID)
			*this\sizers\Flags = #AWPB_GUILO_SIZER_PARENT_WINDOW
      *this\sizers\r     = WindowWidth(ParentID)
      *this\sizers\b     = WindowHeight(ParentID)
    ElseIf IsGadget(ParentID)
    	If GadgetType(ParentID) <> #PB_GadgetType_Container
    		*this\sizers\Flags = #AWPB_GUILO_SIZER_PARENT_CONTAINER
    	ElseIf GadgetType(ParentID) <> #PB_GadgetType_Frame3D
    		*this\sizers\Flags = #AWPB_GUILO_SIZER_PARENT_FRAME
    	Else
	    	FreeMemory(*this)
	    	ProcedureReturn #Null
    	EndIf
      *this\sizers\r     = GadgetWidth(ParentID)
      *this\sizers\b     = GadgetHeight(ParentID)
    Else
    	FreeMemory(*this)
    	ProcedureReturn #Null
    EndIf
    *this\sizers\flags					| #AWPB_GUILO_SIZER_VBOX | #AWPB_GUILO_SIZER_REL | #AWPB_GUILO_SIZER_SIZER
    *this\sizers\w        			= *this\sizers\r
		*this\sizers\h        			= *this\sizers\b
		*this\sizers\bleft   			  = 0
		*this\sizers\btop    			  = 0
		*this\sizers\bright   			= 0
		*this\sizers\bbottom  			= 0
		*this\sizers\ibleft   			= 0
		*this\sizers\ibtop    			= 0
		*this\sizers\ibright   			= 0
		*this\sizers\ibbottom  			= 0
		*this\sizers\GadgetID 			= #PB_Any
		*this\sizers\size     			= 100
		*this\sizers\OnBeforeResize = #Null
		*this\sizers\OnAfterResize  = #Null
		
		ProcedureReturn *this
	EndIf
	
	ProcedureReturn #Null
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_DestroyChild(*sizer.____AWPB_GUILO_Sizer_Data)
	ForEach *sizer\childs()
		____AWPB_GUILO_Sizer_DestroyChild(*sizer\childs())
	Next
	FreeList(*sizer\childs())
	FreeMemory(*sizer)
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_Destroy(*this.____AWPB_GUILO_Sizer)
	ForEach *this\sizers\childs()
		____AWPB_GUILO_Sizer_DestroyChild(*this\sizers\childs())
	Next
	FreeList(*this\sizers\childs())
	FreeMemory(*this)
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_FinishChild(*sizer.____AWPB_GUILO_Sizer_Data, ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b)
	Protected l.i, t.i, r.i, b.i, w.i, h.i, gl.i, gt.i, gb.i, gr.i, gw.i, gh.i, ol.i, ot.i, ow.i, oh.i
	
	l = *sizer\l
	t = *sizer\t
	r = *sizer\r
	b = *sizer\b
	w = *sizer\w
	h = *sizer\h
	
	If IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_GADGET) Or IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_FRAME)
		If IsGadget(*sizer\GadgetID)
		  ol = l
		  ot = t
		  ow = w
		  oh = h
			gl = *sizer\l + *sizer\bleft
			gt = *sizer\t + *sizer\btop
			gr = *sizer\r - *sizer\bright
			gb = *sizer\b - *sizer\bbottom
			If gl > gr : gl = *sizer\l : EndIf
			If gt > gb : gl = *sizer\t : EndIf
			If gr < gl : gr = *sizer\r : EndIf
			If gb < gt : gb = *sizer\b : EndIf
			gw = gr - gl
			gh = gb - gt 
	    If (l <> ol) Or (t <> ot) Or (gw <> ow) Or (gh <> oh)
	  		If ExecuteBeforeResizeCallbacks 
		  	  If *sizer\OnBeforeResize <> #Null
			      *sizer\OnBeforeResize(*sizer\GadgetID)
			    EndIf  
			  EndIf  
  			ResizeGadget(*sizer\GadgetID, gl, gt, gw, gh)
	  		If ExecuteAfterResizeCallbacks 
		  	  If *sizer\OnAfterResize <> #Null
			      *sizer\OnAfterResize(*sizer\GadgetID, gl, gt, gw, gh)
			    EndIf  
			  EndIf  
			EndIf
		EndIf
	EndIf
	If IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_SIZER)
		If IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_FRAME)
			With *sizer
				l = \l + \bleft   + \ibleft
				t = \t + \btop    + \ibtop
				r = \r - \bright  - \ibright
				b = \b - \bbottom - \ibbottom
				w = \w - \bleft   - \ibleft   - \bright  - \ibright
				h = \h - \btop    + \ibtop    - \bbottom - \ibbottom
			EndWith
		EndIf
		ForEach *sizer\childs()
			With *sizer\childs()
				If IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_HBOX)
					; horizontal - t, b and h static
					\t = t
					\b = b
					\h = h
					If IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_FIX)
						\l = l
						\w = \size
						\r = \l + \w - 1
						l  = \r + 1
					ElseIf IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_REL)
						\l = l
						\w = (w * \size) / 100
						\r = \l + \w - 1
						l  = \r + 1
					EndIf
				ElseIf IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_VBOX)
					; vertical - l, r and w static
					\l = l
					\r = r
					\w = w
					If IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_FIX)
						\t = t
						\h = \size
						\b = \t + \h - 1
						t  = \b + 1
					ElseIf IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_REL)
						\t = t
						\h = (h * \size) / 100
						\b = \t + \h - 1
						t  = \b + 1
					EndIf
				EndIf
			EndWith
			____AWPB_GUILO_Sizer_FinishChild(*sizer\childs(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
		Next
	EndIf
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_Finish(*this.____AWPB_GUILO_Sizer, ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	____AWPB_GUILO_Sizer_FinishChild(@*this\sizers, ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_Resize(*this.____AWPB_GUILO_Sizer, ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	If IsFlag(*this\sizers\flags, #AWPB_GUILO_SIZER_PARENT_WINDOW)
		*this\sizers\r        = WindowWidth(*this\ParentID)
    *this\sizers\b        = WindowHeight(*this\ParentID)
  ElseIf IsFlag(*this\sizers\flags, #AWPB_GUILO_SIZER_PARENT_CONTAINER) Or IsFlag(*this\sizers\flags, #AWPB_GUILO_SIZER_PARENT_FRAME)
    *this\sizers\r        = GadgetWidth(*this\ParentID)
    *this\sizers\b        = GadgetHeight(*this\ParentID)
	EndIf
	*this\sizers\w = *this\sizers\r
	*this\sizers\h = *this\sizers\b
	____AWPB_GUILO_Sizer_Finish(*this, ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
EndProcedure
Procedure.b ____AWPB_GUILO_Sizer_AddGadget(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, GadgetID.i, Size.i, BorderLeft.i = 0, BorderTop.i = 0, BorderRight.i = 0, BorderBottom.i = 0, *OnBeforeResizeCallback.AWPB_GUILO_OnBeforeResize_Proto = #Null, *OnAfterResizeCallback.AWPB_GUILO_OnAfterResize_Proto = #Null)
	Protected *sizer.____AWPB_GUILO_Sizer_Data
	
	If IsGadget(GadgetID) 
		*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
		If *sizer
			InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
			With *sizer
				\flags          = #AWPB_GUILO_SIZER_GADGET
				\size     			= Size
				\bleft    			= BorderLeft
				\btop     			= BorderTop
				\bright   			= BorderRight
				\bbottom  			= BorderBottom
				\ibleft    			= 0
				\ibtop     			= 0
				\ibright   			= 0
				\ibbottom  			= 0
				\GadgetID 			= GadgetID
				\OnBeforeResize = *OnBeforeResizeCallback
				\OnAfterResize  = *OnAfterResizeCallback
			EndWith
			
			If *ParentSizer
				AddElement(*ParentSizer\childs())
				*ParentSizer\childs() = *sizer
			Else
				AddElement(*this\sizers\childs())
				*this\sizers\childs() = *sizer
			EndIf
			
			ProcedureReturn #True
		EndIf
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_AddSizer(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, Flags.i, Size.i)
	Protected *sizer.____AWPB_GUILO_Sizer_Data
	
	*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
	If *sizer
		InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
		With *sizer
			\flags					= #AWPB_GUILO_SIZER_SIZER
			If IsFlag(Flags, #AWPB_GUILO_SIZER_HBOX)
				\flags				| #AWPB_GUILO_SIZER_HBOX
			Else
				\flags				| #AWPB_GUILO_SIZER_VBOX
			EndIf
			If IsFlag(Flags, #AWPB_GUILO_SIZER_REL)
				\flags				| #AWPB_GUILO_SIZER_REL
			Else
				\flags				| #AWPB_GUILO_SIZER_FIX
			EndIf		
			\size     			= Size
			\bleft    			= 0
			\btop     			= 0
			\bright   			= 0
			\bbottom  			= 0
			\ibleft    			= 0
			\ibtop     			= 0
			\ibright   			= 0
			\ibbottom  			= 0
			\GadgetID 			= #PB_Any
			\OnBeforeResize = #Null
			\OnAfterResize  = #Null
		EndWith
		
		If *ParentSizer
			AddElement(*ParentSizer\childs())
			*ParentSizer\childs() = *sizer
		Else
			AddElement(*this\sizers\childs())
			*this\sizers\childs() = *sizer
		EndIf
	EndIf
	
	ProcedureReturn *sizer		
EndProcedure
Procedure.b ____AWPB_GUILO_Sizer_AddSpacer(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, Size.i)
	Protected *sizer.____AWPB_GUILO_Sizer_Data
	
	*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
	If *sizer
		InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
		With *sizer
			\flags					= #AWPB_GUILO_SIZER_SPACER
			\size     			= Size
			\bleft    			= 0
			\btop     			= 0
			\bright   			= 0
			\bbottom  			= 0
			\ibleft    			= 0
			\ibtop     			= 0
			\ibright   			= 0
			\ibbottom  			= 0
			\GadgetID 			= #PB_Any
			\OnBeforeResize = #Null
			\OnAfterResize  = #Null
		EndWith
		
		If *ParentSizer
			AddElement(*ParentSizer\childs())
			*ParentSizer\childs() = *sizer
		Else
			AddElement(*this\sizers\childs())
			*this\sizers\childs() = *sizer
		EndIf
		
		ProcedureReturn #True
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_AddFramedSizer(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, GadgetID.i, Flags.i, Size.i, BorderLeft.i = 0, BorderTop.i = 0, BorderRight.i = 0, BorderBottom.i = 0, *OnBeforeResizeCallback.AWPB_GUILO_OnBeforeResize_Proto = #Null, *OnAfterResizeCallback.AWPB_GUILO_OnAfterResize_Proto = #Null, InnerBorderLeft.i = #PB_Any, InnerBorderTop.i = #PB_Any, InnerBorderRight.i = #PB_Any, InnerBorderBottom.i = #PB_Any)
	Protected *sizer.____AWPB_GUILO_Sizer_Data
	
	If IsGadget(GadgetID)
		If GadgetType(GadgetID) = #PB_GadgetType_Frame3D
			If InnerBorderBottom = #PB_Any : InnerBorderBottom = 10 : EndIf
			If InnerBorderLeft   = #PB_Any : InnerBorderLeft   = 10 : EndIf
			If InnerBorderRight  = #PB_Any : InnerBorderRight  = 10 : EndIf
			If InnerBorderTop    = #PB_Any
				InnerBorderTop = 10
				CompilerSelect #PB_Compiler_OS
					CompilerCase #PB_OS_Linux
						If GetGadgetText(GadgetID) <> "" 
							InnerBorderTop = ____AWPB_GetGadgetTextHeight(GadgetID)
						EndIf
					CompilerCase #PB_OS_Windows
						If GetGadgetText(GadgetID) <> "" 
							InnerBorderTop = ____AWPB_GetGadgetTextHeight(GadgetID) + 10
						EndIf
				CompilerEndSelect
			EndIf
			*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
			If *sizer
				InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
				With *sizer
					\flags					= #AWPB_GUILO_SIZER_SIZER | #AWPB_GUILO_SIZER_FRAME
					If IsFlag(Flags, #AWPB_GUILO_SIZER_HBOX)
						\flags				| #AWPB_GUILO_SIZER_HBOX
					Else
						\flags				| #AWPB_GUILO_SIZER_VBOX
					EndIf
					If IsFlag(Flags, #AWPB_GUILO_SIZER_REL)
						\flags				| #AWPB_GUILO_SIZER_REL
					Else
						\flags				| #AWPB_GUILO_SIZER_FIX
					EndIf		
					\size     			= Size
					\bleft    			= BorderLeft
					\btop     			= BorderTop
					\bright   			= BorderRight
					\bbottom  			= BorderBottom
					\ibleft    			= InnerBorderLeft
					\ibtop     			= InnerBorderTop
					\ibright   			= InnerBorderRight
					\ibbottom  			= InnerBorderBottom
					\GadgetID 			= GadgetID
					\OnBeforeResize = *OnBeforeResizeCallback
					\OnAfterResize  = *OnAfterResizeCallback
				EndWith
			
				If *ParentSizer
					AddElement(*ParentSizer\childs())
					*ParentSizer\childs() = *sizer
				Else
					AddElement(*this\sizers\childs())
					*this\sizers\childs() = *sizer
				EndIf
			EndIf
		EndIf
	EndIf
	
	ProcedureReturn *sizer		
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_MinWidth(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data = #Null)
	;- TODO
	  
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_MinHeight(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data = #Null)
	;- TODO
	
EndProcedure
 
DataSection ;{
____AWPB_GUILO_Sizer_VT:
  Data.i @____AWPB_GUILO_Sizer_Destroy()
  Data.i @____AWPB_GUILO_Sizer_Finish()
  Data.i @____AWPB_GUILO_Sizer_Resize()
  Data.i @____AWPB_GUILO_Sizer_AddGadget()
  Data.i @____AWPB_GUILO_Sizer_AddSizer()
  Data.i @____AWPB_GUILO_Sizer_AddSpacer()
  Data.i @____AWPB_GUILO_Sizer_AddFramedSizer()
  Data.i @____AWPB_GUILO_Sizer_MinWidth()
  Data.i @____AWPB_GUILO_Sizer_MinHeight()  
EndDataSection ;}
;}

